"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parser = exports.transformAST = void 0;
const wrapAstTransformation_1 = __importDefault(require("../../src/wrapAstTransformation"));
const report_1 = require("../../src/report");
/**
 * Process component names that have been changed in element plus
 * @param content
 */
const transformAST = ({ root, j }) => {
    const cntFunc = report_1.getCntFunc('element-plus-upgrade', subRules);
    // find element-ui import
    const elementPlusImport = root.find(j.ImportDeclaration, {
        source: {
            value: 'element-plus'
        }
    });
    if (elementPlusImport.length) {
        elementPlusImport.forEach(({ node }) => {
            let newSpecifier = [];
            node.specifiers.forEach(importNode => {
                var _a;
                cntFunc();
                if (importNode.type === 'ImportSpecifier') {
                    newSpecifier.push(j.importSpecifier(j.identifier('El' + ((_a = importNode.local) === null || _a === void 0 ? void 0 : _a.name)), importNode.local));
                    node.specifiers = newSpecifier;
                }
                else {
                    newSpecifier.push(j.importDefaultSpecifier(j.identifier(importNode.local.name)));
                    node.specifiers = newSpecifier;
                }
            });
        });
    }
};
exports.transformAST = transformAST;
exports.default = wrapAstTransformation_1.default(exports.transformAST);
exports.parser = 'babylon';
