"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parser = exports.transformAST = void 0;
const wrapAstTransformation_1 = __importDefault(require("../../src/wrapAstTransformation"));
const report_1 = require("../../src/report");
/**
 * Upgrade element-ui to element-plus
 * @param content
 */
const transformAST = ({ root, j }) => {
    const cntFunc = report_1.getCntFunc('element-plus-import', subRules);
    // find element-ui import
    const elementPlusImport = root.find(j.ImportDeclaration, node => {
        return node.source.value.toString().startsWith('element-ui');
    });
    if (elementPlusImport.length) {
        elementPlusImport.forEach(({ node }) => {
            var _a;
            node.source.value =
                'element-plus' + ((_a = node.source.value) === null || _a === void 0 ? void 0 : _a.toString().substring('element-ui'.length));
        });
        cntFunc();
    }
};
exports.transformAST = transformAST;
exports.default = wrapAstTransformation_1.default(exports.transformAST);
exports.parser = 'babylon';
