"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parser = exports.transformAST = void 0;
const wrapAstTransformation_1 = __importDefault(require("../../src/wrapAstTransformation"));
const report_1 = require("../../src/report");
const transformAST = context => {
    const { root, j, filename } = context;
    const rootNodes = root
        .find(j.MemberExpression, {
        object: {
            name: 'Vue'
        }
    })
        .filter((node) => { var _a; return ((_a = node === null || node === void 0 ? void 0 : node.value.property) === null || _a === void 0 ? void 0 : _a.name) !== 'createApp'; });
    if (rootNodes) {
        rootNodes.forEach((node) => {
            const path = filename;
            const name = 'Global Vue API is changed to use an application instance';
            const suggest = "The rule of thumb is any APIs that globally mutate Vue's behavior are now moved to the app instance.";
            const website = 'https://v3.vuejs.org/guide/migration/global-api.html#a-new-global-api-createapp';
            report_1.pushManualList(path, node, name, suggest, website);
        });
    }
};
exports.transformAST = transformAST;
exports.default = wrapAstTransformation_1.default(exports.transformAST);
exports.parser = 'babylon';
