"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parser = exports.transformAST = void 0;
const wrapAstTransformation_1 = __importDefault(require("../../src/wrapAstTransformation"));
const report_1 = require("../../src/report");
const transformAST = context => {
    const { root, j, filename } = context;
    const rootNodes = root.find(j.Identifier, {
        name: 'VueRouter'
    });
    if (rootNodes) {
        rootNodes.forEach((node) => {
            const path = filename;
            const name = 'Removed VueRouter';
            const suggest = "The rule of thumb is any APIs that globally mutate VueRouter's behavior are now moved to the app instance.";
            const website = 'https://next.router.vuejs.org/guide/migration/index.html#moved-the-base-option';
            report_1.pushManualList(path, node, name, suggest, website);
        });
    }
};
exports.transformAST = transformAST;
exports.default = wrapAstTransformation_1.default(exports.transformAST);
exports.parser = 'babylon';
