"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parser = exports.transformAST = void 0;
const wrapAstTransformation_1 = __importDefault(require("../../src/wrapAstTransformation"));
const report_1 = require("../../src/report");
const transformAST = context => {
    const { root, j, filename } = context;
    const rootNodes = root
        .find(j.Identifier, {
        name: 'filters'
    })
        .filter((node) => { var _a; return ((_a = node === null || node === void 0 ? void 0 : node.value.property) === null || _a === void 0 ? void 0 : _a.name) !== 'createApp'; });
    if (rootNodes) {
        rootNodes.forEach((node) => {
            const path = filename;
            const name = 'Removed Filters';
            const suggest = 'Filters are removed from Vue 3.0 and no longer supported.';
            const website = 'https://v3.vuejs.org/guide/migration/filters.html#overview';
            report_1.pushManualList(path, node, name, suggest, website);
        });
    }
    const rootNodes2 = root.find(j.MemberExpression, {
        object: {
            name: 'Vue'
        },
        property: {
            name: 'filter'
        }
    });
    if (rootNodes2) {
        rootNodes2.forEach((node) => {
            const path = filename;
            const name = 'remove global filters';
            const suggest = 'Instead, you can make your global filters available to all components through globalProperties: ';
            const website = 'https://v3.vuejs.org/guide/migration/filters.html#global-filters';
            report_1.pushManualList(path, node, name, suggest, website);
        });
    }
};
exports.transformAST = transformAST;
exports.default = wrapAstTransformation_1.default(exports.transformAST);
exports.parser = 'babylon';
