"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parser = exports.transformAST = void 0;
const wrapAstTransformation_1 = __importDefault(require("../../src/wrapAstTransformation"));
const report_1 = require("../../src/report");
const transformAST = context => {
    const { root, j, filename } = context;
    const rootNodes = root.find(j.ObjectProperty, {
        key: {
            name: 'path'
        },
        value: {
            value: '*'
        }
    });
    if (rootNodes) {
        rootNodes.forEach((node) => {
            const path = filename;
            const name = 'Removed * routes';
            const suggest = 'Catch all routes (*, /*) must now be defined using a parameter with a custom regex.';
            const website = 'https://next.router.vuejs.org/guide/migration/index.html#removal-of-the-fallback-option';
            report_1.pushManualList(path, node, name, suggest, website);
        });
    }
};
exports.transformAST = transformAST;
exports.default = wrapAstTransformation_1.default(exports.transformAST);
exports.parser = 'babylon';
