"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parser = exports.transformAST = void 0;
const wrapAstTransformation_1 = __importDefault(require("../src/wrapAstTransformation"));
const report_1 = require("../src/report");
const transformAST = ({ root, j }) => {
    var _a;
    const cntFunc = report_1.getCntFunc('move-app-mount', global.outputReport);
    const appMount = root.find(j.ExpressionStatement, {
        expression: {
            callee: {
                object: {
                    name: 'app'
                },
                property: {
                    name: 'mount'
                }
            }
        }
    });
    if (appMount.length !== 1) {
        return;
    }
    const appMountOnly = appMount.get();
    let lastend = appMountOnly.value.end;
    let appMountEnd = appMountOnly.value.end;
    let lastNode = appMountOnly;
    const context = (_a = appMountOnly.value.expression) === null || _a === void 0 ? void 0 : _a.arguments[0].value;
    root.find(j.ExpressionStatement).forEach(node => {
        if (j(node).find(j.Identifier, {
            name: 'app'
        }).length > 0) {
            // @ts-ignore
            const end = node.value.end;
            if (end < appMountEnd) {
                appMount.insertBefore(node.value);
                j(node).remove();
            }
            if (end > lastend) {
                lastend = end;
                lastNode = node;
            }
        }
    });
    if (lastend !== appMountOnly.value.end) {
        appMount.remove();
        j(lastNode).insertAfter(j.expressionStatement(j.callExpression(j.memberExpression(j.identifier('app'), j.identifier('mount')), [j.stringLiteral(context)])));
        cntFunc();
    }
};
exports.transformAST = transformAST;
exports.default = wrapAstTransformation_1.default(exports.transformAST);
exports.parser = 'babylon';
