"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parser = exports.transformAST = void 0;
const wrapAstTransformation_1 = __importDefault(require("../src/wrapAstTransformation"));
const report_1 = require("../src/report");
const transformAST = ({ root, j }) => {
    // find the Vue.nextTick(...)
    const nextTickCalls = root.find(j.CallExpression, n => {
        return (n.callee.type === 'MemberExpression' &&
            n.callee.property.name === 'nextTick' &&
            n.callee.object.name === 'Vue');
    });
    if (nextTickCalls.length) {
        // add import nextTick
        const addImport = require('./add-import');
        addImport.transformAST({ root, j }, {
            specifier: {
                type: 'named',
                imported: 'nextTick'
            },
            source: 'vue'
        });
        nextTickCalls.replaceWith(({ node }) => {
            const el = node.arguments[0];
            return j.callExpression(j.identifier('nextTick'), [el]);
        });
        // stats
        const cntFunc = report_1.getCntFunc('next-tick', subRules);
        cntFunc();
    }
};
exports.transformAST = transformAST;
exports.default = wrapAstTransformation_1.default(exports.transformAST);
exports.parser = 'babylon';
