"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parser = exports.transformAST = void 0;
const wrapAstTransformation_1 = __importDefault(require("../../src/wrapAstTransformation"));
const report_1 = require("../../src/report");
// addRoute() addRoutes()-> forEach addRoute
const transformAST = context => {
    const { root, j } = context;
    const cntFunc = report_1.getCntFunc('router-update-addRoute', global.outputReport);
    const addRouteExpression = root.find(j.CallExpression, {
        callee: {
            type: 'MemberExpression',
            property: {
                type: 'Identifier',
                name: 'addRoute'
            }
        }
    });
    if (addRouteExpression.length) {
        addRouteExpression.replaceWith(({ node }) => {
            // Multiple parameters are not supported
            const routerArgs = node.arguments[0];
            const routerCallee = node.callee;
            if (!(routerCallee.object.name === 'router' ||
                routerCallee.object.name === 'route')) {
                return node;
            }
            const arrowFun = root.find(j.ArrowFunctionExpression, {
                params: [
                    {
                        type: 'Identifier',
                        name: routerArgs.name
                    }
                ],
                body: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        property: {
                            type: 'Identifier',
                            name: 'addRoute'
                        }
                    }
                }
            });
            if (arrowFun.length) {
                return node;
            }
            cntFunc();
            return j.callExpression(j.memberExpression(routerArgs, j.identifier('forEach')), [
                j.arrowFunctionExpression([j.identifier('item')], j.callExpression(routerCallee, [j.identifier('item')]))
            ]);
        });
    }
    const addRoutesExpression = root.find(j.CallExpression, {
        callee: {
            type: 'MemberExpression',
            property: {
                type: 'Identifier',
                name: 'addRoutes'
            }
        }
    });
    addRoutesExpression.replaceWith(({ node }) => {
        const routerArgs = node.arguments[0];
        const routerCallee = node.callee;
        if (!(routerCallee.object.name === 'router' ||
            routerCallee.object.name === 'route')) {
            return node;
        }
        if (routerCallee.property.name === 'addRoutes') {
            routerCallee.property.name = 'addRoute';
        }
        return j.callExpression(j.memberExpression(routerArgs, j.identifier('forEach')), [
            j.arrowFunctionExpression([j.identifier('item')], j.callExpression(routerCallee, [j.identifier('item')]))
        ]);
    });
};
exports.transformAST = transformAST;
exports.default = wrapAstTransformation_1.default(exports.transformAST);
exports.parser = 'babylon';
