"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parser = exports.transformAST = void 0;
const wrapAstTransformation_1 = __importDefault(require("../src/wrapAstTransformation"));
const next_tick_1 = require("./next-tick");
const observable_1 = require("./observable");
const version_1 = require("./version");
const remove_extraneous_import_1 = require("./remove-extraneous-import");
const report_1 = require("../src/report");
const transformAST = context => {
    const beforeCount = Object.keys(subRules).reduce((sum, key) => sum + subRules[key], 0);
    next_tick_1.transformAST(context);
    observable_1.transformAST(context);
    version_1.transformAST(context);
    // remove import 'Vue' from 'vue' if not used
    remove_extraneous_import_1.transformAST(context, { localBinding: 'Vue' });
    const afterCount = Object.keys(subRules).reduce((sum, key) => sum + subRules[key], 0);
    const change = afterCount - beforeCount;
    const cntFunc = report_1.getCntFunc('tree-shaking', global.outputReport);
    cntFunc(change);
};
exports.transformAST = transformAST;
exports.default = wrapAstTransformation_1.default(exports.transformAST);
exports.parser = 'babylon';
