"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parser = exports.transformAST = void 0;
const wrapAstTransformation_1 = __importDefault(require("../src/wrapAstTransformation"));
const report_1 = require("../src/report");
const transformAST = ({ root, j }) => {
    // find Vue.version
    const versionCalls = root.find(j.MemberExpression, n => {
        return n.property.name === 'version' && n.object.name === 'Vue';
    });
    if (versionCalls.length) {
        const addImport = require('./add-import');
        addImport.transformAST({ root, j }, {
            specifier: {
                type: 'named',
                imported: 'version'
            },
            source: 'vue'
        });
        versionCalls.replaceWith(({ node }) => {
            // @ts-ignore
            const property = node.property.name;
            return j.identifier(property);
        });
        // stats
        const cntFunc = report_1.getCntFunc('version', subRules);
        cntFunc();
    }
};
exports.transformAST = transformAST;
exports.default = wrapAstTransformation_1.default(exports.transformAST);
exports.parser = 'babylon';
